#ifndef EVAL_SUB_H
#define EVAL_SUB_H

#include "eval_op.h"

typedef std::map<std::string, std::shared_ptr<eval_op>> eval_op_proto_map;

class eval_sub: public eval_op {
    tensor compute(const tensor &a, const tensor &b);
    std::shared_ptr<eval_op> clone(const expression &expr) override;
public:
    eval_sub() {}
    eval_sub(const expression &expr): eval_op(expr) {}
    void eval(vars_type &variables, const kwargs_type &kwargs) override;
    static void store_prototype(eval_op_proto_map &proto_map) {
        assert(proto_map.find("Sub") == proto_map.end());
        proto_map["Sub"] = std::make_shared<eval_sub>(); // where is expr?
    }

}; // class eval_sub

#endif